unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls;



const

 AND_OP       = 0;
 OR_OP        = 1;
 XOR_OP       = 2;
 NOT_OP       = 3;
 SHL_OP       = 4;
 SHR_OP       = 5;

 BITS_8       = 0;
 BITS_16      = 1;
 BITS_32      = 2;

 HI_BYTE_INDEX    = 0;
 LO_BYTE_INDEX    = 1;
 WORD_INDEX       = 2;



type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    tabBitwiseOperations: TTabSheet;
    tabBitManipulation: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    lblNot: TLabel;
    lblHiSet: TLabel;
    lblLoSet: TLabel;
    Label6: TLabel;
    Bevel1: TBevel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lblWordSet: TLabel;
    btnBytesOrder_Number: TButton;
    edtWord_Num: TEdit;
    edtHiByte_Num: TEdit;
    edtLoByte_Num: TEdit;
    btnIsBitSet: TButton;
    Edit4: TEdit;
    rgWhichByte: TRadioGroup;
    UpDown: TUpDown;
    btnBitToON: TButton;
    btnBitToOFF: TButton;
    btnBitSwicth: TButton;
    btnReverseBits: TButton;
    btnOperate: TButton;
    rgOperators: TRadioGroup;
    rgBitsNumber: TRadioGroup;
    grBits: TGroupBox;
    edtBinA: TEdit;
    edtBinB: TEdit;
    edtBinResult: TEdit;
    grNumbers: TGroupBox;
    edtNumA: TEdit;
    edtNumB: TEdit;
    edtNumResult: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Bevel2: TBevel;
    Label16: TLabel;
    grBitsFromNums: TGroupBox;
    edtWord_Bits: TEdit;
    edtHiByte_Bits: TEdit;
    edtLoByte_Bits: TEdit;
    procedure btnOperateClick(Sender: TObject);
    procedure btnBytesOrder_NumberClick(Sender: TObject);
    procedure btnIsBitSetClick(Sender: TObject);
    procedure btnBitToONClick(Sender: TObject);
    procedure btnBitToOFFClick(Sender: TObject);
    procedure btnBitSwicthClick(Sender: TObject);
    procedure btnReverseBitsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure OrderNumbersToBits;

  end;


var
  Form1: TForm1;


implementation

{$R *.DFM}

uses
  BitUnit;








{---------------------------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
begin
 btnOperateClick(Sender);
end;



{---------------------------------------------------------------------------------}
procedure TForm1.btnOperateClick(Sender: TObject);
var
 NumOfBits    : integer;
 NumA         : integer;
 NumB         : integer;
 NumResult    : integer;
 i            : integer;
 S:string;
begin

   // convert to integers
   NumA :=StrToInt(edtNumA.Text);
   NumB :=StrToInt(edtNumB.Text);

   // perform the proper operation
   case rgOperators.ItemIndex of
     AND_OP  : NumResult:= NumA and NumB;
     OR_OP   : NumResult:= NumA or  NumB;
     XOR_OP  : NumResult:= NumA xor NumB;
     NOT_OP  : NumResult:= not NumA;
     SHL_OP  : NumResult:= NumA shl NumB;
     SHR_OP  : NumResult:= NumA shr NumB;
   end;

   // get the number of bits
   case rgBitsNumber.ItemIndex of
     BITS_8   : NumOfBits := 8;
     BITS_16  : NumOfBits := 16;
     BITS_32  : NumOfBits := 32;
   end;


   // convert the integers to bits and show them
   S:='';
   for i:=NumOfBits - 1 downto 0 do
   if IsBitSet(NumA, i) then S:=S + '1' else S:=S + '0';
   edtBinA.Text:=S;


   S:='';
   for i:=NumOfBits - 1 downto 0 do
   if IsBitSet(NumB, i) then S:=S + '1' else S:=S + '0';
   edtBinB.Text:=S;


   S:='';
   for i:=NumOfBits - 1 downto 0 do
   if IsBitSet(NumResult, i) then S:=S + '1' else S:=S + '0';
   edtBinResult.Text:=S;

   edtNumResult.Text:=IntToStr(NumResult);

end;   { btnOperateClick }



{------------------btnBytesOrder_NumberClick---------------------------------------
 divides a number (word) to Hi and Lo byte
 and then makes a binary representation of them
-----------------------------------------------------------------------------------}
procedure TForm1.btnBytesOrder_NumberClick(Sender: TObject);
var
 N:word;
begin

 N:=StrToInt((edtWord_Num.Text));
 edtHiByte_Num.Text:=IntToStr(Hi(N));
 edtLoByte_Num.Text:=IntToStr(Lo(N));

 OrderNumbersToBits;
 
end;    {btnBytesOrder_NumberClick }
                                        






{------------------btnIsBitSetClick------------------------------------------------
 checks if a bit is ON and displays a message in a Label
----------------------------------------------------------------------------------}
procedure TForm1.btnIsBitSetClick(Sender: TObject);
begin
  lblHiSet.Visible   :=False;
  lblLoSet.Visible   :=False;
  lblNot.Visible     :=False;
  lblWordSet.Visible :=False;

  case rgWhichByte.ItemIndex of
    HI_BYTE_INDEX  :
         begin
           if IsBitSet(StrToInt(edtHiByte_Num.Text), UpDown.Position)
           then lblHiSet.Visible:=True
           else lblNot.Visible:=True;
         end;
    LO_BYTE_INDEX :
         begin
           if IsBitSet(StrToInt(edtLoByte_Num.Text), UpDown.Position)
           then lblLoSet.Visible:=True
           else lblNot.Visible:=True;
         end;
    WORD_INDEX   :
         begin
           if IsBitSet(StrToInt(edtWord_Num.Text), UpDown.Position)
           then lblWordSet.Visible:=True
           else lblNot.Visible:=True;
         end;
  end;
end;     { btnIsBitSetClick }



{------------------btnBitToONClick-------------------------------------------------
 set a bit On
-----------------------------------------------------------------------------------}
procedure TForm1.btnBitToONClick(Sender: TObject);
begin
  case rgWhichByte.ItemIndex of
    HI_BYTE_INDEX : edtHiByte_Num.Text :=IntToStr(BitToOn(StrToInt(edtHiByte_Num.Text), UpDown.Position));
    LO_BYTE_INDEX : edtLoByte_Num.Text :=IntToStr(BitToOn(StrToInt(edtLoByte_Num.Text), UpDown.Position));
    WORD_INDEX    : edtWord_Num.Text   :=IntToStr(BitToOn(StrToInt(edtWord_Num.Text), UpDown.Position));
  end;
  OrderNumbersToBits;
end;   { btnBitToONClick }



{------------------btnBitToOFFClick------------------------------------------------
 set a bit OFF
-----------------------------------------------------------------------------------}
procedure TForm1.btnBitToOFFClick(Sender: TObject);
begin
  case rgWhichByte.ItemIndex of
    HI_BYTE_INDEX : edtHiByte_Num.Text :=IntToStr(BitToOFF(StrToInt(edtHiByte_Num.Text), UpDown.Position));
    LO_BYTE_INDEX : edtLoByte_Num.Text :=IntToStr(BitToOFF(StrToInt(edtLoByte_Num.Text), UpDown.Position));
    WORD_INDEX    : edtWord_Num.Text   :=IntToStr(BitToOFF(StrToInt(edtWord_Num.Text), UpDown.Position));
  end;
  OrderNumbersToBits;
end;    { btnBitToOFFClick }



{------------------btnBitSwicthClick-----------------------------------------------
 switch the state of a bit
-----------------------------------------------------------------------------------}
procedure TForm1.btnBitSwicthClick(Sender: TObject);
begin
  case rgWhichByte.ItemIndex of
    HI_BYTE_INDEX : edtHiByte_Num.Text :=IntToStr(BitSwitch(StrToInt(edtHiByte_Num.Text), UpDown.Position));
    LO_BYTE_INDEX : edtLoByte_Num.Text :=IntToStr(BitSwitch(StrToInt(edtLoByte_Num.Text), UpDown.Position));
    WORD_INDEX    : edtWord_Num.Text   :=IntToStr(BitSwitch(StrToInt(edtWord_Num.Text), UpDown.Position));
  end;
  OrderNumbersToBits;
end;  { btnBitSwicthClick }



{---------------------------------------------------------------------------------}
procedure TForm1.btnReverseBitsClick(Sender: TObject);
begin
  case rgWhichByte.ItemIndex of
    HI_BYTE_INDEX : edtHiByte_Num.Text :=IntToStr(ReverseAllBits(StrToInt(edtHiByte_Num.Text)));
    LO_BYTE_INDEX : edtLoByte_Num.Text :=IntToStr(ReverseAllBits(StrToInt(edtLoByte_Num.Text)));
    WORD_INDEX    : edtWord_Num.Text   :=IntToStr(ReverseAllBits(StrToInt(edtWord_Num.Text)));
  end;
  OrderNumbersToBits;
end;


{------------------------OrderNumbersToBits-----------------------------------------
  makes a binary representation of the numbers
-----------------------------------------------------------------------------------}
procedure TForm1.OrderNumbersToBits;
var
 i:integer;
 B:byte;
 W:integer;
 S:string;
begin

 { Hi byte }
 S:='';
 B:=StrToInt(edtHiByte_Num.Text);
 for i:=7 downto 0 do
   if IsBitSet(B, i) then S:=S + '1' else S:=S + '0';
   edtHiByte_Bits.Text:=S;

 { Lo byte }
 S:='';
 B:=StrToInt(edtLoByte_Num.Text);
 for i:=7 downto 0 do
   if IsBitSet(B, i) then S:=S + '1' else S:=S + '0';
   edtLoByte_Bits.Text:= S;

 { Word }
 S:='';
 W:=StrToInt(edtWord_Num.Text);
 for i:=31 downto 0 do
   if IsBitSet(W, i) then S:=S + '1' else S:=S + '0';
   edtWord_Bits.Text:= S;

end;    { OrderNumbersToBits }


end.
